#include "dllclass.h"
#include <stdio.h>
#include <iostream.h>

int 
DllClassBase::virtual_method () const 
{ 
  printf ("DLL routine %s\n", __PRETTY_FUNCTION__);
  return -1; 
}

DllClass::DllClass (int i) : i_(i) { 
  printf ("DLL routine %s\n", __PRETTY_FUNCTION__);
}

DllClass::~DllClass () { 
  printf ("DLL routine %s\n", __PRETTY_FUNCTION__);
}

int 
DllClass::virtual_method () const 
{
  printf ("DLL routine %s\n", __PRETTY_FUNCTION__);
  return i_ * i_ * i_; 
}

int 
DllClass::non_virtual_method () const 
{
  cerr << "DLL method: " << __PRETTY_FUNCTION__ << endl;
  return i_ * i_;
}

DLLIMPORT DllClass* new_dllclass (int i) {
  return new DllClass (i);
}

DLLIMPORT void delete_dllclass (DllClass *dllclass) {
  delete dllclass;
}

DLLIMPORT int non_virtual_method (const DllClass* dllclass) {
  return dllclass->non_virtual_method ();
}

DLLIMPORT int virtual_method (const DllClass* dllclass) {
  return dllclass->virtual_method ();
}

